<?php

namespace IPS\membersshop\extensions\trophies\TrophyCriteria;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}


class _membersshop
{

    public static function isActive()
    {
        return TRUE;
    }

	public static function getExtraAreas( \IPS\Helpers\Form &$form , \IPS\trophies\Trophy $trophy = NULL )
	{
	
	}

	public static function addMemberCriteria( \IPS\Helpers\Form &$form , \IPS\trophies\Trophy $trophy = NULL )
	{
	    $form->addHeader('ms_trophy_members_shop');
		$form->add( new \IPS\Helpers\Form\Number( 'trophy_shop_points', isset( $trophy->id, $trophy->crdata['shop_points'] ) ? $trophy->crdata['shop_points'] : NULL ) );
	    $form->add( new \IPS\Helpers\Form\Number( 'trophy_items_redeemed', isset( $trophy->id, $trophy->crdata['items_redeemed'] ) ? $trophy->crdata['items_redeemed'] : NULL ) );
	    $form->add( new \IPS\Helpers\Form\Number( 'trophy_sent_items', isset( $trophy->id, $trophy->crdata['sent_items'] ) ? $trophy->crdata['sent_items'] : NULL ) );
	
	}

	public static function addContentCriteria( \IPS\Helpers\Form &$form , \IPS\trophies\Trophy $trophy = NULL )
	{

	}

	public static function handleForm( &$values, &$data )
	{
		foreach( [
					'shop_points',
					'items_redeemed',
					'sent_items'
				  ]
				  AS $field )
		{
			if( isset( $values[$field] ) )
			{
				if( $values[$field] > 0 )
				{
					$data[$field] = $values[$field];
				}

				unset( $values[$field] );
			}
		}
	}

	public static function memberMeetsCriteria( \IPS\Member $member, \IPS\trophies\Trophy $trophy, &$failedStep = NULL  )
	{
		if( isset( $trophy->crdata['shop_points'] ) AND $trophy->crdata['shop_points'] > 0 )
		{
			try
			{
				$count = \IPS\Db::i()->select( 'points', 'membersshop_points', [ 'member_id=?', $member->member_id ] )->first();
				
				if( $count >= $trophy->crdata['shop_points'] )
				{
					return TRUE;
				}
				else
				{
					$failedStep = 'shop points given - min : ' . $trophy->crdata['shop_points'] . " and member has : " . $count;
					return FALSE;
				}
			}
			catch ( \UnderflowException $e )
			{
				return FALSE;
			}
		}
		
		if( isset( $trophy->crdata['items_redeemed'] ) AND $trophy->crdata['items_redeemed'] > 0 )
		{
			try
			{
				$count = \IPS\Db::i()->select( 'count(*)', 'membersshop_purchases', [ 'member_id=? AND redeemed=?', $member->member_id, 1 ] )->first();
				if( $count >= $trophy->crdata['items_redeemed'] )
				{
					return TRUE;
				}
				else
				{
					$failedStep = 'Items redeemed - min : ' . $trophy->crdata['items_redeemed'] . " and member has : " . $count;
					return FALSE;
				}
			}
			catch ( \UnderflowException $e )
			{
				return FALSE;
			}
		}
		
		if( isset( $trophy->crdata['sent_items'] ) AND $trophy->crdata['sent_items'] > 0 )
		{
			try
			{
				$count = \IPS\Db::i()->select( 'count(*)', 'membersshop_sent_items', [ 'sender_id=?', $member->member_id ] )->first();
				if( $count >= $trophy->crdata['sent_items'] )
				{
					return TRUE;
				}
				else
				{
					$failedStep = 'Items sent - min : ' . $trophy->crdata['sent_items'] . " and member has : " . $count;
					return FALSE;
				}
			}
			catch ( \UnderflowException $e )
			{
				return FALSE;
			}
		}
		
        return TRUE;
	}


}