//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_DownloadsHook extends _HOOK_CLASS_
{
	public function _download( \IPS\File $file )
	{
		try
		{
			try
			{
				if( !\IPS\Settings::i()->ms_disable_downloads_hooks )
				{
					try
					{
						$downloadNode = \IPS\membersshop\Downloads::load( $this->file->id, 'file_id' );
					}
					catch( \Exception $e )
					{
						$downloadNode = FALSE;
					}
		
					$pointsName = \IPS\Settings::i()->ms_points_name;
					$downloader = \IPS\Member::loggedIn();
					$uploadAuthor = $this->file->author();
		
					if( $this->file->shopPoints() AND $uploadAuthor->member_id != $downloader->member_id AND !$this->file->isPaid() )
					{
						if( \IPS\Db::i()->select( 'count(*)', 'membersshop_paid_downloads', array( 'member_id=? AND file_id=?', $downloader->member_id, $this->file->id ) )->first() === 0 )
						{
							if( $downloader->shopPoints() < $this->file->shopPoints() )
							{
								\IPS\Output::i()->error( \IPS\Member::loggedIn()->language()->addToStack('ms_you_dont_have_enough_points_downloads', FALSE, array( 'sprintf' => array( $pointsName ) ) ), 'MEMBERSSHOP/1', 403, '' );
							}
		
							$myNumber = $this->file->shopPoints();
							$percentToGet = \IPS\Settings::i()->ms_downloads_commission;
							$percentInDecimal = $percentToGet / 100;
							$result = $percentInDecimal * $myNumber;
							$return = $myNumber - $result;
		
							$pointsName = \IPS\Settings::i()->ms_points_name;
		
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_file_download_author'), $this->file->url(), $this->file->name  );
							$uploadAuthor->addPoints ( $return, $logsACP );
		
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_file_download'), $this->file->url(), $this->file->name  );
							$downloader->removePoints ( $this->file->shopPoints(), $logsACP );
		
							$downloadNode = new \IPS\membersshop\Downloads;
							$downloadNode->file_id = $this->file->id;
							$downloadNode->member_id = $downloader->member_id;
							$downloadNode->time_date = time();
							$downloadNode->points = $return;
							$downloadNode->save();
		
							$reward = new \IPS\membersshop\Rewards;
							$reward->item_id = -5;
							$reward->member_id = $uploadAuthor->member_id;
							$reward->time_date = time();
							$reward->reward = $return;
							$reward->save();	
						}
					}
		
			/*if( $downloadNode == FALSE AND $uploadAuthor != $downloader )
			{
				try
				{
					$points = \IPS\membersshop\Downloads\Points::load( $this->file->container()->_id, 'cat_id' )->points_for_download;
				}
				catch( \OutOfRangeException $e )
				{
					$points = 0;
				}

				if( $points AND \IPS\Settings::i()->ms_group_gain_forums == 'all' OR $points AND \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_group_gain_forums ) ) )
				{
					if( $points > 0 )
					{ 
						if( $downloader != $uploadAuthor )
						{
							$pointsName = \IPS\Settings::i()->ms_points_name;
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_file_download_author'), $this->file->url(), $this->file->name  );
								
							$uploadAuthor->addPoints( $points, $logsACP ); 
							$reward = new \IPS\membersshop\Rewards;
							$reward->item_id = -5;
							$reward->member_id = $uploadAuthor->member_id;
							$reward->time_date = time();
							$reward->reward = $points;
							$reward->save();
						}
					}
				}
			}*/
				}
		
				return parent::_download( $file );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}