//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_ForumsFrontTopics extends _HOOK_CLASS_
{
	public function bestAnswer()
	{
		try
		{
			try
			{
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					$topic = \IPS\forums\Topic::load( \IPS\Request::i()->id );
					$post = \IPS\forums\Topic\Post::load( \IPS\Request::i()->answer );
		
					try
					{
						$points = \IPS\membersshop\Forums\Points::load( $topic->container()->id, 'forum_id' )->points_per_best_answer;
					}
					catch ( \OutOfRangeException $e )
					{
						$points = 0;
					}
		
					if( !$topic->topic_answered_pid )
					{
						$addPoints = \IPS\Member::load( $post->author_id );
						$pointsName = \IPS\Settings::i()->ms_points_name;
			
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_best_answer'), $topic->url(), $topic->title, $post->url() );
						$addPoints->addPoints( $points, $logsACP );
		
						$reward = new \IPS\membersshop\Rewards;
						$reward->item_id = -15;
						$reward->member_id = $addPoints->member_id;
						$reward->time_date = time();
						$reward->reward = $points;
						$reward->extra_field = $topic->tid;
						$reward->save();
					}
					else
					{
						$bestAnswer = \IPS\forums\Topic\Post::load( $topic->topic_answered_pid );
						$pointsName = \IPS\Settings::i()->ms_points_name;
		
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_lost_best_answer'), $topic->url(), $topic->title, $post->url() );
						$removePoints = \IPS\Member::load( $bestAnswer->author_id );
						$removePoints->removePoints( $points, $logsACP );
		
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_best_answer'), $topic->url(), $topic->title, $post->url() );
						$addPoints = \IPS\Member::load( $post->author_id );
						$addPoints->addPoints( $points, $logsACP );
						$addPoints->save();
		
						\IPS\Db::i()->update( 'membersshop_rewards', array( 'member_id' => $addPoints->member_id ), array( 'extra_field=? AND member_id=?', $topic->tid, $removePoints->member_id ) );
					}
				}
		
				parent::bestAnswer();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function unsetBestAnswer()
	{
		try
		{
			try
			{
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					$topic = \IPS\forums\Topic::load( \IPS\Request::i()->id );
					$post = \IPS\forums\Topic\Post::load( $topic->topic_answered_pid );
		
					try
					{
						$points = \IPS\membersshop\Forums\Points::load( $topic->container()->_id, 'forum_id' )->points_per_best_answer;
					}
					catch ( \OutOfRangeException $e )
					{
						$points = 0;
					}
		
					$pointsName = \IPS\Settings::i()->ms_points_name;
		
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_lost_best_answer'), $topic->url(), $topic->title, $post->url() );
					$removePoints = \IPS\Member::load( $post->author_id );
					$removePoints->removePoints( $points, $logsACP );
		
					\IPS\Db::i()->delete( 'membersshop_rewards', array( 'extra_field=? AND member_id=?', $topic->tid, $removePoints->member_id ) );
				}
		
				parent::unsetBestAnswer();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
