//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_ReactHook extends _HOOK_CLASS_
{
	protected function react()
	{
		try
		{
			try
			{
				$class = static::$contentModel;
				if( \IPS\Settings::i()->ms_apps_reactions != '*' AND !\in_array( $class, \IPS\Settings::i()->ms_apps_reactions ) )
				{
					return parent::react();
				}
		
				$item = $class::load( \IPS\Request::i()->id );
		
				if( \IPS\Settings::i()->ms_group_gain_forums == 'all' or $item->author()->inGroup( explode( ',', \IPS\Settings::i()->ms_group_gain_forums ) ) )
				{
					$loggedIn = \IPS\Member::loggedIn()->member_id;
					try
					{
					    $AlreadyGot = \IPS\Db::i()->select( 'member_id', 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->id ), $item->author()->member_id, $loggedIn ) )->first();
					}
					catch( \Exception $ex )
					{
						$AlreadyGot = FALSE;
					}
		
					if( $AlreadyGot == FALSE )
					{
					    $member = $item->author();
		
						try
						{
							$points = \IPS\membersshop\Reactions::load( \IPS\Request::i()->reaction, 'reaction_id' )->points;
						}
						catch( \Exception $e )
						{
							$points = 0;
						}
		
						$pointsName = \IPS\Settings::i()->ms_points_name;
		
						if( $points != 0 )
						{
							$reaction = \IPS\Content\Reaction::load( \IPS\Request::i()->reaction );
							$reactionTitle = \IPS\Member::loggedIn()->language()->get('reaction_title_'.$reaction->id.'');
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_reaction'), \IPS\Member::loggedIn()->name, $reactionTitle );
							$member->addPoints( $points, $logsACP );
		
							$reward = new \IPS\membersshop\Rewards;
						    $reward->item_id = -1;
						    $reward->member_id = $member->member_id;
						    $reward->time_date = time();
						    $reward->reward = $points;
							$reward->stolen_from = \intval( \IPS\Request::i()->id );
							$reward->extra_field = $loggedIn;
						    $reward->save();
						}
					}
				}
			
		
				return parent::react();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function unreact()
	{
		try
		{
			try
			{
				$class = static::$contentModel;
		
				if( \IPS\Settings::i()->ms_apps_reactions != '*' AND !\in_array( $class, \IPS\Settings::i()->ms_apps_reactions ) )
				{
					return parent::unreact();
				}
		
				$item = $class::load( \IPS\Request::i()->id );
				$loggedIn = \IPS\Member::loggedIn()->member_id;
				$member_id = \IPS\Db::i()->select( 'member_id', 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->id ), $item->author()->member_id, $loggedIn ) )->first();
				$points = \IPS\Db::i()->select( 'reward', 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->id ), $item->author()->member_id, $loggedIn ) )->first();
		        $member = \IPS\Member::load( $member_id );
				$pointsName = \IPS\Settings::i()->ms_points_name;
		
				if( $points )
				{
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_lost_reaction'), \IPS\Member::loggedIn()->name );
					$member->removePoints( $points, $logsACP );
				}
		
				\IPS\Db::i()->delete( 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->id ), $item->author()->member_id, $loggedIn ) );
		
				return parent::unreact();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function _react( $commentClass, $comment, $item )
	{
		try
		{
			try
			{
				if( \IPS\Settings::i()->ms_apps_reactions != '*' AND !\in_array( $commentClass, \IPS\Settings::i()->ms_apps_reactions ) )
				{
						return parent::_react( $commentClass, $comment, $item );
				}
		
				if( \IPS\Settings::i()->ms_group_gain_forums == 'all' or $comment->author()->inGroup( explode( ',', \IPS\Settings::i()->ms_group_gain_forums ) ) )
				{
					$loggedIn = \IPS\Member::loggedIn()->member_id;
					try
					{
					    $AlreadyGot = \IPS\Db::i()->select( 'member_id', 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->comment ), $comment->author()->member_id, $loggedIn ) )->first();
					}
					catch( \Exception $ex )
					{
						$AlreadyGot = FALSE;
					}
		
					if( $AlreadyGot == FALSE )
					{
						$member = $comment->author();
		
						try
						{
							$points = \IPS\membersshop\Reactions::load( \IPS\Request::i()->reaction, 'reaction_id' )->points;
						}
						catch( \Exception $e )
						{
							$points = 0;
						}
		
						$pointsName = \IPS\Settings::i()->ms_points_name;
		
						if( $points != 0 )
						{
							$reaction = \IPS\Content\Reaction::load( \IPS\Request::i()->reaction );
							$reactionTitle = \IPS\Member::loggedIn()->language()->get('reaction_title_'.$reaction->id.'');
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_reaction'), \IPS\Member::loggedIn()->name, $reactionTitle );
							$member->addPoints( $points, $logsACP );
		
							$reward = new \IPS\membersshop\Rewards;
						    $reward->item_id = -1;
						    $reward->member_id = $member->member_id;
						    $reward->time_date = time();
						    $reward->reward = $points;
							$reward->stolen_from = \intval( \IPS\Request::i()->comment );
							$reward->extra_field = $loggedIn;
						    $reward->save();
						}
					}
				}
		
				return parent::_react( $commentClass, $comment, $item );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	protected function _unreact( $commentClass, $comment, $item )
	{
		try
		{
			try
			{
				if( \IPS\Settings::i()->ms_apps_reactions != '*' AND !\in_array( $commentClass, \IPS\Settings::i()->ms_apps_reactions ) )
				{
					return parent::_unreact( $commentClass, $comment, $item );
				}
		
				$loggedIn = \IPS\Member::loggedIn()->member_id;
				$member_id = \IPS\Db::i()->select( 'member_id', 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->comment ), $comment->author()->member_id, $loggedIn ) )->first();
				$points = \IPS\Db::i()->select( 'reward', 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->comment ), $comment->author()->member_id, $loggedIn ) )->first();
		        $member = \IPS\Member::load( $member_id );
				$pointsName = \IPS\Settings::i()->ms_points_name;
				
				if( $points )
				{
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_lost_reaction'), \IPS\Member::loggedIn()->name );
					$member->removePoints( $points, $logsACP );
				}
				
				\IPS\Db::i()->delete( 'membersshop_rewards', array( 'item_id=? AND stolen_from=? AND member_id=? AND extra_field=?', -1, \intval( \IPS\Request::i()->comment ), $comment->author()->member_id, $loggedIn ) );
		
				return parent::_unreact( $commentClass, $comment, $item );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}