//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_RegisterHook extends _HOOK_CLASS_
{
	public static function buildRegistrationForm( $postBeforeRegister = NULL )
	{
		try
		{
			try
			{
				$form = parent::buildRegistrationForm( $postBeforeRegister );
				
				if( \IPS\Settings::i()->ms_enable_referrer_points )
				{
					$form->add( new \IPS\Helpers\Form\Member( 'ms_referrer_setting', NULL, FALSE, array( ) ), 'password_confirm' );
				}
		
				return $form;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	public static function _createMember( $values, $profileFields, $postBeforeRegister, &$form )
	{
		try
		{
			try
			{
				$parent = parent::_createMember( $values, $profileFields, $postBeforeRegister, $form );
					
				if( \IPS\Settings::i()->ms_enable_referrer_points AND isset( $values['ms_referrer_setting'] ) )
				{
					$amount = \IPS\Settings::i()->ms_referrer_points;
					$awardTo = \IPS\Member::load( $values['ms_referrer_setting']->member_id );
					$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_referrer'), $parent->url(), $parent->name );
					$awardTo->addPoints( $amount, $logsACP );
					$awardTo->save();
				}
				
		        return $parent;
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	catch ( \Error | \RuntimeException $e )
	{
		if ( method_exists( get_parent_class(), __FUNCTION__ ) )
		{
			return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
		}
		else
		{
			throw $e;
		}
	}
    }
}