//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_TopicHook extends _HOOK_CLASS_
{
	protected function processAfterCreate( $comment, $values )
	{
		try
		{
			try
			{
			    parent::processAfterCreate( $comment, $values );
		
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					if( $this->container()->club() )
					{
						if( \IPS\Settings::i()->ms_club_points_tstarter )
						{
							$points = \IPS\Settings::i()->ms_club_points_tstarter;
						}
						else
						{
							$points = NULL;
						}
					}
					else
					{
						try
						{
							$points = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_per_topic;
						}
						catch ( \OutOfRangeException $e )
						{
							$points = 0;
						}
					}
		
					if( $points AND \IPS\Settings::i()->ms_group_gain_forums == 'all' AND \IPS\Member::loggedIn()->member_id or $points AND \IPS\Member::loggedIn()->inGroup( explode(',', \IPS\Settings::i()->ms_group_gain_forums ) ) AND \IPS\Member::loggedIn()->member_id )
					{
						$topicAuthor = $comment->author();
						$pointsName = \IPS\Settings::i()->ms_points_name;
		
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_created'), $this->url(), $this->title );
						$topicAuthor->addPoints( $points, $logsACP );
		
						$reward = new \IPS\membersshop\Rewards;
						$reward->item_id = -2;
						$reward->member_id = $topicAuthor->member_id;
						$reward->time_date = time();
						$reward->reward = $points;
						$reward->save();
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	public function processCommentForm( $values )
	{       
		try
		{
			try
			{
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					if( $this->container()->club() )
					{
						if( \IPS\Settings::i()->ms_club_points_treply )
						{
							$points = \IPS\Settings::i()->ms_club_points_treply;
						}
						else
						{
							$points = NULL;
						}
					}
					else
					{
						try
						{
							$points = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_per_reply;
						}
						catch ( \OutOfRangeException $e )
						{
							$points = 0;
						}
		
						try
						{
							$pointsToTS = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_to_ts_pr;
						}
						catch ( \OutOfRangeException $e )
						{
							$pointsToTS = 0;
						}
					}
		
					if( \IPS\Member::loggedIn()->member_id AND ( \IPS\Settings::i()->ms_group_gain_forums == 'all' OR \IPS\Member::loggedIn()->inGroup( explode( ',', \IPS\Settings::i()->ms_group_gain_forums ) ) ) )
					{
						$topicAuthor = $this->author();
						$postAuthor  = \IPS\Member::loggedIn();
						$pointsName  = \IPS\Settings::i()->ms_points_name;
		
						if( $points AND $postAuthor->member_id != $topicAuthor->member_id )
						{
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_reply'), $this->url(), $this->title );
							$postAuthor->addPoints( $points, $logsACP );
		
							$reward = new \IPS\membersshop\Rewards;
							$reward->item_id = -3;
							$reward->member_id = $postAuthor->member_id;
							$reward->time_date = time();
							$reward->reward = $points;
							$reward->save();
						}
		
						if( $pointsToTS AND $postAuthor->member_id == $topicAuthor->member_id )
						{
							$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_reply_starter'), $this->url(), $this->title );
							$topicAuthor->addPoints( $pointsToTS, $logsACP );
		
							$reward = new \IPS\membersshop\Rewards;
							$reward->item_id = -4;
							$reward->member_id = $topicAuthor->member_id;
							$reward->time_date = time();
							$reward->reward = $pointsToTS;
							$reward->save();						
						}
					}
				}
		
				return parent::processCommentForm( $values );
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	public function delete()
	{
		try
		{
			try
			{
				parent::delete();
		
				if( !\IPS\Settings::i()->ms_disable_forum_hooks )
				{
					if( \IPS\Settings::i()->ms_remove_on_delete )
					{
						try
						{
							$points = \IPS\membersshop\Forums\Points::load( $this->container()->_id, 'forum_id' )->points_per_topic;
						}
						catch ( \OutOfRangeException $e )
						{
							$points = 0;
						}
		
						$topicAuthor = $this->author();
						$pointsName = \IPS\Settings::i()->ms_points_name;
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_topic_deleted'), $this->title );
						$topicAuthor->removePoints( $points, $logsACP );
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}