<?php


namespace IPS\membersshop\modules\admin\bank;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * stats
 */
class _stats extends \IPS\Dispatcher\Controller
{
	/**
	 * @brief	Has been CSRF-protected
	 */
	public static $csrfProtected = TRUE;
	
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$chart = new \IPS\Helpers\Chart\Database( \IPS\Http\Url::internal( "app=membersshop&module=bank&controller=stats" ), 'membersshop_bank_transactions', 'time_date', '', array( 
			'isStacked' => FALSE,
			'backgroundColor' 	=> '#ffffff',
			'colors'			=> array( '#10967e', '#ea7963', '#de6470', '#6b9dde', '#b09be4', '#eec766', '#9fc973', '#e291bf', '#55c1a6', '#5fb9da' ),
			'hAxis'				=> array( 'gridlines' => array( 'color' => '#f5f5f5' ) ),
			'lineWidth'			=> 1,
			'areaOpacity'		=> 0.4
		), 
			'AreaChart',
			'daily' 
		);

		$chart->addSeries( \IPS\Member::loggedIn()->language()->addToStack('ms_deposited_amount'), 'number', 'SUM(amount)' );
		$chart->addSeries( \IPS\Member::loggedIn()->language()->addToStack('ms_total_charges'), 'number', 'SUM(charge)' );
		$chart->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_bank_graph' );
		$chart->availableTypes = array( 'AreaChart', 'LineChart', 'ColumnChart', 'BarChart' );
		
		$pieChart = new \IPS\Helpers\Chart;
		$pieChart->addHeader( "Member Group", 'string' );
		$pieChart->addHeader( "Points", 'number' );
		
		foreach( \IPS\Db::i()->select( 'g_id', 'core_groups', 'g_id IS NOT NULL AND g_id!=2' ) as $gName )
		{
			$sum = \IPS\Db::i()->select( 'SUM(points)', 'membersshop_bank', array( 'm_group_id=?', $gName ) )->first();
			$group = \IPS\Member\Group::load( $gName )->name;
		    $pieChart->addRow( array( $group, $sum ) );
		}
		
		
		$pieChart1 = new \IPS\Helpers\Chart;
		$pieChart1->addHeader( "Member Group", 'string' );
		$pieChart1->addHeader( "Interest", 'number' );
		
		foreach( \IPS\Db::i()->select( 'g_id', 'core_groups', 'g_id IS NOT NULL AND g_id!=2' ) as $groups )
		{
			$sum = \IPS\Db::i()->select( 'SUM(points)', 'membersshop_bank', array( 'm_group_id=?', $groups ) )->first();
			$group = \IPS\Member\Group::load( $groups );
			$myNumber = $sum;
			$percentToGet = $group->ms_bank_interest;
			$percentInDecimal = $percentToGet / 100;
			$amount = $percentInDecimal * $myNumber;
			$pieChart1->addRow( array( $group->name, round($amount) ) );
		}
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('menu__membersshop_bank_stats');
		
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'bank' )->main( (string) $chart, $pieChart->render( 'PieChart', array(
			'title'	=> "Group Points",
			'is3D'	=> TRUE,
			'chartArea' => array( 
				'width' =>"90%", 
				'height' => "90%"
			) 
		)),
		$pieChart1->render( 'PieChart', array(
			'title'	=> "Group Points",
			'is3D'	=> TRUE,
			'chartArea' => array( 
				'width' =>"90%", 
				'height' => "90%"
			) 
		))
		);
	}
	
	// Create new methods with the same name as the 'do' parameter which should execute it
}