<?php

namespace IPS\membersshop\modules\admin\points;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _settings extends \IPS\Dispatcher\Controller
{
	protected function manage()
	{
		$pointsName = \IPS\Settings::i()->ms_points_name;
		$form = new \IPS\Helpers\Form;
		$form->addTab('ms_points_settings');
		$form->addHeader('ms_points_name_header');
		$form->add( new \IPS\Helpers\Form\Text( 'ms_points_name', \IPS\Settings::i()->ms_points_name, TRUE, array( ), NULL, NULL, NULL, 'ms_points_name' ) );

		$form->addHeader('ms_who_can_gain');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_group_gain_forums', ( \IPS\Settings::i()->ms_group_gain_forums == 'all' ) ? 'all' : explode( ',', \IPS\Settings::i()->ms_group_gain_forums ), TRUE, array( 'options' => \IPS\Member\Group::groups(TRUE, FALSE), 'parse' => 'normal', 'multiple' => true, 'unlimited' => 'all', 'unlimitedLang' => 'all_groups' ), NULL, NULL, NULL, 'ms_group_gain_forums' ) );

		$form->addHeader('ms_display_points');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_profile_header', \IPS\Settings::i()->ms_show_profile_header, FALSE, array() ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_posts', \IPS\Settings::i()->ms_show_posts, FALSE, array() ) );

		if( \IPS\Application::appIsEnabled( 'calendar' ) )
		{
			$form->addHeader('ms_disable_calendar_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_calendar_hooks', \IPS\Settings::i()->ms_disable_calendar_hooks, FALSE, array(), NULL, NULL, NULL, 'ms_disable_calendar_hooks' ) );
		}

		if( \IPS\Settings::i()->clubs )
		{
			$form->addHeader('ms_disable_clubs_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_clubs_hooks', \IPS\Settings::i()->ms_disable_clubs_hooks, FALSE, array(), NULL, NULL, NULL, 'ms_disable_clubs_hooks' ) );
		}

		if( \IPS\Application::appIsEnabled( 'downloads' ) )
		{
			$form->addHeader('ms_disable_downloads_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_downloads_hooks', \IPS\Settings::i()->ms_disable_downloads_hooks, FALSE, array(), NULL, NULL, NULL, 'ms_disable_downloads_hooks' ) );
		}

		if( \IPS\Application::appIsEnabled( 'forums' ) )
		{
			$form->addHeader('ms_disable_forum_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_forum_hooks', \IPS\Settings::i()->ms_disable_forum_hooks, FALSE, array(), NULL, NULL, NULL, 'ms_disable_forum_hooks' ) );
		}

		if( \IPS\Application::appIsEnabled( 'gallery' ) )
		{
			$form->addHeader('ms_disable_gallery_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_gallery_hooks', \IPS\Settings::i()->ms_disable_gallery_hooks, FALSE, array(), NULL, NULL, NULL, 'ms_disable_gallery_hooks' ) );
		}

		if( \IPS\Application::appIsEnabled( 'nexus' ) )
		{
			$form->addHeader('ms_disable_nexus_hook_header');
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_disable_nexus_hooks', \IPS\Settings::i()->ms_disable_nexus_hooks, FALSE, array(), NULL, NULL, NULL, 'ms_disable_nexus_hooks' ) );
		}

		if( \IPS\Application::appIsEnabled( 'nexus') )
		{
			\IPS\Output::i()->sidebar['actions']['nexus'] = array(
				'primary'	=> true,
				'icon'		=> 'dollar',
				'title'		=> '__app_nexus',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings&do=pointPurchaseSettings' ),
				'data'		=> array()
			);	
		}

		$form->addTab('ms_bonus_points');
		$form->addHeader('ms_register_header');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_activate_register', \IPS\Settings::i()->ms_activate_register, FALSE, array('togglesOn' => array( 'ms_register_points' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_register_points', \IPS\Settings::i()->ms_register_points, FALSE, array( ), NULL, NULL, NULL, 'ms_register_points' ) );
		$form->addHeader( 'ms_bonus_header' );
		$form->add( new \IPS\Helpers\Form\Radio( 'ms_task_points', \IPS\Settings::i()->ms_task_points, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'ms_task_points', 'options' => array( 'member_last_post' => 'widget__sort_last_post', 'last_visit' => 'widget__sort_visit', 'last_activity' => 'widget__sort_activity', 'no_restriction' => 'no_restriction' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_task_points') );

        if( $values = $form->values() )
        {
			$form->saveAsSettings();
	        \IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'saved' );
	        return TRUE;
        }

		\IPS\Output::i()->sidebar['actions']['remove'] = array(
		    'icon'		=> 'remove',
			'title'		=> 'ms_reset_shop_points',
			'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings&do=resetpoints' )->csrf(),
			'data'		=> array( 'ipsDialog' => '', 'ipsDialog-title' => \IPS\Member::loggedIn()->language()->addToStack('ms_reset_shop_points') )
		);

		\IPS\Output::i()->sidebar['actions']['add'] = array(
			'primary'	=> true,
			'icon'		=> 'star',
			'title'		=> 'ms_Award_points',
			'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings&do=awardPoints' )->csrf(),
			'data'		=> array( 'ipsDialog' => '', 'ipsDialog-title' => \IPS\Member::loggedIn()->language()->addToStack('ms_Award_points') )
		);

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('ms_points', FALSE, array( 'sprintf' => array( $pointsName ) ) );
		\IPS\Output::i()->output = $form;
	}

	protected function awardPoints()
	{
		$pointsName = \IPS\Settings::i()->ms_points_name;

		$form = new \IPS\Helpers\Form;
        $form->add( new \IPS\Helpers\Form\Radio( 'ms_award_groups', NULL, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'ms_award_groups',
		'options' => array(
			0  => 'Member',
			1  => 'Groups',),
		 'toggles' => array(
			0 => array('ms_award_member'),
			1 => array('ms_award_what_group'),
		) ), NULL, NULL, NULL, 'ms_award_groups'));

		$form->add( new \IPS\Helpers\Form\Member( 'ms_award_member', NULL, FALSE, array( 'max' => 1 ), NULL, NULL, NULL, 'ms_award_member' ) );
		$form->add( new \IPS\Helpers\Form\Select( 'ms_award_what_group', NULL, FALSE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ), NULL, NULL, NULL, 'ms_award_what_group' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_award_amount', NULL, FALSE, array( 'min' => 1 ), NULL, NULL, NULL, 'ms_award_amount' ) );

		if( $values = $form->values() )
        {
			if( $values['ms_award_member']  )
			{
				$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_awarded_member'), \IPS\Member::loggedIn()->name, $pointsName );
				$values['ms_award_member']->addPoints( $values['ms_award_amount'], $logsACP );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'ms_points_awarded' );
	        }

			if( $values['ms_award_groups'] = 1  )
			{
			    foreach( \IPS\Db::i()->select( '*', 'core_members', array( 'member_group_id=?', $values['ms_award_what_group'] ) ) as $members )
				{
					try
					{
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_awarded_groups'), \IPS\Member::loggedIn()->name, $pointsName );
						$member = \IPS\Member::load( $members['member_id'] );
						$member->addPoints( $values['ms_award_amount'], $logsACP  );
					}
					catch( \Exception $e ){}
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'ms_points_awarded' );
			}

			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Nothing Has Been Done' );
        }		

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_Award_points' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function evotoshoppoints()
	{		
		$cycle = \IPS\Request::i()->cycle;

		\IPS\Output::i()->title  = \IPS\Member::loggedIn()->language()->addToStack( 'ms_transfer_points' );

		\IPS\Output::i()->output = new \IPS\Helpers\MultipleRedirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings&do=evotoshoppoints&cycle=50' ),
		function( $data ) use ( $cycle )
		{
			$select	= \IPS\Db::i()->select( '*', 'core_members', NULL, NULL, array( \is_array( $data ) ? $data['done'] : 0, $cycle ) );

			$total = $select->count( TRUE );
			$cycle = \IPS\Request::i()->cycle;

			if( !$select->count() )
			{
				return NULL;
			}

			if( !\is_array( $data ) )
			{
				$data = array( 'total' => $total, 'done' => 0 );
			}

			foreach( $select AS $members )
			{
				$member	= \IPS\Member::constructFromData( $members );
				$member->shop_points = $member->shop_points + $member->evox_points;
				$member->evox_points = 0;
				$member->save();
			}

			$data['done'] += $cycle;

			if( $data['done'] > $data['total'] )
			{
				$data['done'] = $data['total'];
			}

			return array( $data, \IPS\Member::loggedIn()->language()->addToStack('ms_transfering_points', FALSE, array( 'sprintf' => array( $data['done'], $data['total'] ) ) ),( $data['done'] / $data['total'] ) * 100 );
		}, function()
		{
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'All evox_points are now added to Shop Points' );
		} );
	}
	
	protected function resetpoints()
	{
		$pointsName = \IPS\Settings::i()->ms_points_name;
		
		$form = new \IPS\Helpers\Form;
        $form->addHeader('ms_reset_all_points');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_mass_reset', 'no', FALSE, array( 'options' => array_merge( array( 'no' => 'No', 'yes' => 'Yes' ) ) ) ) );
		$form->addHeader('ms_reset_member_groups');
		$form->add( new \IPS\Helpers\Form\Member( 'ms_reset_member', NULL, FALSE, array( 'max' => 1 ), NULL, NULL, NULL, 'ms_reset_member' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_select_reset_groups', NULL, FALSE, array('togglesOn' => array( 'ms_reset_groups' ), 'togglesOff' => array( 'ms_reset_member' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Select( 'ms_reset_groups', NULL, FALSE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ), NULL, NULL, NULL, 'ms_reset_groups' ) );
		
		if( $values = $form->values() )
        {
	        if( $values['ms_mass_reset'] == 'yes' )
			{
				foreach( \IPS\Db::i()->select( '*', 'core_members', array( 'member_id IS NOT NULL' ) ) as $member )
				{
					try
					{
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_reset_all'), \IPS\Member::loggedIn()->name, $pointsName );
						$member = \IPS\Member::load( $member['member_id'] );
						$member->resetPoints( $member->shopPoints(), $logsACP  );
					}
					catch( \Exception $e ){}
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Reset' );
	        }
			
			if( $values['ms_reset_member']  )
			{
				$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_reset_member'), \IPS\Member::loggedIn()->name, $pointsName );
				$values['ms_reset_member']->resetPoints( $values['ms_reset_member']->shopPoints(), $logsACP );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Reset' );
	        }
			
			if( $values['ms_select_reset_groups'] == TRUE  )
			{
				$group_id = $values['ms_reset_groups'];
				foreach( \IPS\Db::i()->select( '*', 'core_members', array( 'member_group_id=?', $group_id ) ) as $member )
				{
					try
					{
						$logsACP = sprintf( \IPS\Member::loggedIn()->language()->get('ms_acp_log_reset_groups'), \IPS\Member::loggedIn()->name, $pointsName );
						$member = \IPS\Member::load( $member['member_id'] );
						$member->resetPoints( $member->shopPoints(), $logsACP  );
					}
					catch( \Exception $e ){}
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Reset' );
	        }
			
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Nothing has been done' );
		}

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_reset_points' );
		\IPS\Output::i()->output = $form;
	}
}