<?php


namespace IPS\membersshop\modules\front\bank;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * transactions
 */
class _transactions extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		\IPS\Output::i()->cssFiles = array_merge( \IPS\Output::i()->cssFiles, \IPS\Theme::i()->css( 'membersshop.css', 'membersshop', 'front' ) );
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		if( !\IPS\Member::loggedIn()->member_id )
		{
			\IPS\Output::i()->error( 'no_module_permission_guest', 'MEMBERSSHOP/1', 403, '' );
		}
		
		$member_id = \IPS\Member::loggedIn()->member_id;
		
		$table = new \IPS\Helpers\Table\Db( 'membersshop_bank_transactions', \IPS\Http\Url::internal( 'app=membersshop&module=bank&controller=transactions' ) );
		$table->include = array( 'id', 'member_id', 'amount', 'charge', 'transaction', 'time_date', 'balance' );
		$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate( 'bank' ), 'rows' );
		$table->joins = array();
		$table->limit = 10;
		$table->where[] = array( 'member_id=?', $member_id );
		$table->langPrefix = 'ms__';
		$table->sortOptions = array( 'time_date' => 'time_date' );
		$table->sortBy = $table->sortBy ?: 'time_date';
		if( $table->sortBy === 'time_date' )
		{
			$table->sortDirection = 'DESC';
		}
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('ms_bank_transactions');
		\IPS\Output::i()->breadcrumb[] = array( NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_bank_transactions') );
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'bank' )->template( (string) $table );
	}
}