<?php


namespace IPS\membersshop\setup\upg_11003;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 1.1.3 Upgrade Code
 */
class _Upgrade
{
	/**
	 * ...
	 *
	 * @return	array	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step1()
	{
		foreach( \IPS\Db::i()->select( '*', 'core_permission_index', array( 'app=? AND perm_type=?', 'membersshop', 'items' ) ) as $permission )
		{
			try
			{
				\IPS\Db::i()->update( 'membersshop_items', array( 'groups_view' => $permission['perm_view'], 'groups_buy' => $permission['perm_2'], 'groups_send' => $permission['perm_3'] ), array ( 'id=?', $permission['perm_type_id'] ) );
			}
			catch( \Exception $e ){}
		}
		return TRUE;
	}
	
	// You can create as many additional methods (step2, step3, etc.) as is necessary.
	// Each step will be executed in a new HTTP request
}