<?php

namespace IPS\membersshop\setup\upg_20011;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 2.1.1 Upgrade Code
 */
class _Upgrade
{
	public function step1()
	{
		foreach( \IPS\Db::i()->select( '*', 'membersshop_items', NULL, 'id ASC' ) as $row )
		{
			$item = \IPS\membersshop\Shopitems::constructFromData( $row );
			$item->member = \IPS\Member::loggedIn()->member_id;
			$item->save();
		}

		return TRUE;
	}

	public function step1CustomTitle()
	{
		return "Updating required info on items records";
	}

	public function step2()
	{
		\IPS\Db::i()->delete( 'core_sys_lang_words', array( 'word_app=? AND word_key=?', 'membersshop', 'ms_users_profile' ) );
		\IPS\Db::i()->delete( 'core_sys_lang_words', array( 'word_app=? AND word_key=?', 'membersshop', 'ms_show_posts_header' ) );

		return TRUE;
	}

	public function step2CustomTitle()
	{
		return "Deleting unused language strings";
	}
}