<?php

namespace IPS\membersshop;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _Categories extends \IPS\Node\Model
{
    protected static $multitons;
    
	public static $databaseTable = 'membersshop_item_categories';
    
	public static $nodeTitle = 'ms_members_shop';
    
	public static $subnodeClass = 'IPS\membersshop\Items';
	
	public static $modPerm = 'membersshop_categories';
	
	public static $titleLangPrefix = '';
	
	public static $descriptionLangSuffix = '_desc';
	
	public static $databaseColumnOrder = 'position';
	
	protected $_url	= NULL;
	
	public static $seoTitleColumn = 'name_seo';
	
	public static $urlBase = 'app=membersshop&module=shop&controller=main&do=shopItems&catID=';
	
	public static $urlTemplate = 'membersshop_shopItems';
	
	protected static $databaseIdFields = [ 'id', 'name' ];
	
	protected function get__title()
    {
       return $this->name;
    }
	
	public function canDelete()
	{
		return TRUE;
	}
	
	public function canCopy()
	{
		return FALSE;
	}
	
	public function canAdd()
	{
		return TRUE;
	}
	
	public function form( &$form )
    {		
        $form = new \IPS\Helpers\Form;
		$form->add( new \IPS\Helpers\Form\Text( 'ms_CatTitle', $this->name, TRUE, array( ) ) );
	}
	
	public function formatFormValues( $values )
	{
		if( !$this->id )
		{
			$this->save();
		}
		$this->name = $values['ms_CatTitle'];
		$this->name_seo = \IPS\Http\Url\Friendly::seoTitle( $values['ms_CatTitle'] );
		
		unset( $values['ms_CatTitle'] );
		return $values;
	}
}