<?php

namespace IPS\membersshop\widgets;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _memberpoints extends \IPS\Widget
{
	public $key = 'memberpoints';
	public $app = 'membersshop';
	public $plugin = '';

	public function init()
	{
		$this->template( array( \IPS\Theme::i()->getTemplate( 'widgets', $this->app, 'front' ), $this->key ) );
		parent::init();
	}

	public function configuration( &$form=null )
	{
		$form = parent::configuration( $form );

		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_widget_show_bank', isset( $this->configuration['ms_widget_show_bank'] ) ? $this->configuration['ms_widget_show_bank'] : TRUE, FALSE ) );

 		return $form;
 	} 
 
 	public function preConfig( $values )
 	{
 		return $values;
 	}

	public function render()
	{
		$member 	= \IPS\Member::loggedIn();
		$points 	= number_format( $member->shopPoints() );
		$pointsName = \IPS\Settings::i()->ms_points_name;
		$bank		= $this->configuration['ms_widget_show_bank'];

		return $this->output( $member, $points, $pointsName, $bank );
	}
}