<?php

namespace IPS\membersshop\widgets;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _mostpoints extends \IPS\Widget
{
	public $key = 'mostpoints';
	public $app = 'membersshop';
	public $plugin = '';

	public function init()
	{
		$this->template( array( \IPS\Theme::i()->getTemplate( 'widgets', $this->app, 'front' ), $this->key ) );

		parent::init();
	}
	
	public function configuration( &$form=null )
	{
		$form = parent::configuration( $form );

 		$form->add( new \IPS\Helpers\Form\Number( 'ms_widget_show_amount', isset( $this->configuration['ms_widget_show_amount'] ) ? $this->configuration['ms_widget_show_amount'] : 5, TRUE ) );

 		return $form;
 	} 
 
 	public function preConfig( $values )
 	{
 		return $values;
 	}

	public function render()
	{
		$limit = isset( $this->configuration['ms_widget_show_amount'] ) ? $this->configuration['ms_widget_show_amount'] : 5;
		
		$sort = 'membersshop_points.points DESC';
		
		$select = \IPS\Db::i()->select( '*', 'membersshop_points', array( 'points>?', 0 ), $sort, $limit );
		
		return $this->output( $select, $limit );
	}
}